#!/usr/bin/env ruby
# -*- encoding: utf-8 -*-
# Copyright Freya Dorn <freya.siv.dorn@gmail.com>, 2013
# License: GNU GPL 3 <http://www.gnu.org/copyleft/gpl.html>

class File
  def self.save name, &blk
    name = File.expand_path(name)

    # make sure directory exists
    dir = File.dirname(name)
    FileUtils.mkdir_p dir if not Dir.exist? dir

    # now open it
    file = case name
           when /\.gz$/	; Zlib::GzipWriter.open(name, &blk)
           else        	; File.open(name, "w", &blk)
           end

    file
  end

  def self.load name
    name = File.expand_path(name)

    file = case name
           when /\.gz$/	; Zlib::GzipReader.open(name)
           else        	; File.open(name)
           end

    file
  end
end
